package bakalarka;

import java.awt.GridBagConstraints;
import javax.swing.JPanel;

public class CheckBox {
	public int id;
	public boolean checked = false;
	public Predpis hodnota = new Predpis();
	public String nazov = new String("");
	
	public void setNazov(String nazov) {
		this.nazov = nazov;
	}
	
	public void setID(int id) {
		this.id = id;
	}
	
	public boolean pridajText(String text) {
		return this.hodnota.pridajText(text);
	}
	
	public boolean pridajInputBox(InputBox ib) {
		return this.hodnota.pridajInputBox(ib);
	}
	
	public boolean pridajCheckBox(CheckBox chb) {
		return this.hodnota.pridajCheckBox(chb);
	}
	
	public boolean pridajSelectBox(SelectBox sb) {
		return this.hodnota.pridajSelectBox(sb);
	}
	
	public boolean pridajVstupnySubor(VstupnySubor vs) {
		return this.hodnota.pridajVstupnySubor(vs);
	}
	
	public boolean pridajVystupnySubor(VystupnySubor vs) {
		return this.hodnota.pridajVystupnySubor(vs);
	}
	
	public void enable() {
		this.checked = true;
	}
	
	public void disable() {
		this.checked = false;
	}
	
	public Object getBoxByID(int id) {
		return this.hodnota.getBoxByID(id);
	}
	
	public String getValue() {
		if (this.checked) {
			return this.hodnota.getValue();
		}
		return "";
	}
	
	public String getNormalizedValue() {
		if (this.checked) {
			return this.hodnota.getNormalizedValue();
		}
		return "";
	}
        
        public void paintPanel(SettingsPanel addedPanel, SettingsFrame sFrame) {
            this.hodnota.paintPanel(addedPanel, sFrame);
            if (this.checked) {
                addedPanel.setVisible(true);
            }
            else {
                addedPanel.setVisible(false);
            }
            
        }
       
        
        public String printXML() {
            String result = new String("");
            result = result.concat("<checkbox selected="+'"');
            if (this.checked) {
                result = result.concat("yes");
            }
            else {
                result = result.concat("no");
            }
            result = result.concat('"'+" meno="+'"'+this.nazov+'"'+">");
            result = result.concat(this.hodnota.printXML());
            result = result.concat("</checkbox>");
            return result;
        }
        
        public String printFormattedXML(String tab) {
            String result = new String("");            
            result = result.concat(tab+"<checkbox selected="+'"');
            if (this.checked) {
                result = result.concat("yes");
            }
            else {
                result = result.concat("no");
            }
            result = result.concat('"'+" meno="+'"'+this.nazov+'"'+">"+System.getProperty("line.separator"));
            result = result.concat(this.hodnota.printFormattedXML(tab+ProgramSettingsHandler.tabulator));
            result = result.concat(tab+"</checkbox>"+System.getProperty("line.separator"));
            return result;
        }
}
