package bakalarka;

public class HistoriaDeletedFormat extends HistoriaZaznam {
    
    private Format mazanyFormat;
    private int poradieMazaneho;
    
    public HistoriaDeletedFormat(AdministraciaFrame af, Okruh aktualnyOkruh, Format aktualnyVstupnyFormat, 
            Format aktualnyVystupnyFormat, JednoduchaTransformacia aktualnaTransformacia, Format mazanyFormat, int poradieMazaneho) {
        this.af = af;
        this.aktualnyOkruh = aktualnyOkruh;
        this.aktualnyVstupnyFormat = aktualnyVstupnyFormat;
        this.aktualnyVystupnyFormat = aktualnyVystupnyFormat;
        this.aktualnaTransformacia = aktualnaTransformacia;
        this.mazanyFormat = mazanyFormat;
        this.poradieMazaneho = poradieMazaneho;
    }

    public void undoAction() {
        this.aktualnyOkruh.formaty.add(poradieMazaneho, this.mazanyFormat);
        
        this.af.e.aktualnyOkruh = this.aktualnyOkruh;
        this.af.e.aktualnyVstupnyFormat = this.aktualnyVstupnyFormat;
        this.af.e.aktualnyVystupnyFormat = this.aktualnyVystupnyFormat;
        this.af.e.aktualnaTransformacia = this.aktualnaTransformacia;
        
        this.af.refreshAll();
    }
    
    public void redoAction() {
        this.aktualnyOkruh.formaty.remove(mazanyFormat);
        
        this.af.e.aktualnyOkruh = this.aktualnyOkruh;
        this.af.e.aktualnyVstupnyFormat = null;
        this.af.e.aktualnyVystupnyFormat = null;
        this.af.e.aktualnaTransformacia = null;
        
        this.af.refreshAll();
    }
    
}
