package bakalarka;

public class HistoriaDeletedTransformacia extends HistoriaZaznam {
    
    private JednoduchaTransformacia mazanaTransformacia;
    private int poradieMazaneho;
    
    public HistoriaDeletedTransformacia(AdministraciaFrame af, Okruh aktualnyOkruh, Format aktualnyVstupnyFormat, 
            Format aktualnyVystupnyFormat, JednoduchaTransformacia aktualnaTransformacia, JednoduchaTransformacia mazanaTransformacia, int poradieMazaneho) {
        this.af = af;
        this.aktualnyOkruh = aktualnyOkruh;
        this.aktualnyVstupnyFormat = aktualnyVstupnyFormat;
        this.aktualnyVystupnyFormat = aktualnyVystupnyFormat;
        this.aktualnaTransformacia = aktualnaTransformacia;
        this.mazanaTransformacia = mazanaTransformacia;
        this.poradieMazaneho = poradieMazaneho;
    }

    public void undoAction() {
        this.aktualnyVstupnyFormat.jednoducheTransformacie.add(poradieMazaneho, this.mazanaTransformacia);
        
        this.af.e.aktualnyOkruh = this.aktualnyOkruh;
        this.af.e.aktualnyVstupnyFormat = this.aktualnyVstupnyFormat;
        this.af.e.aktualnyVystupnyFormat = this.aktualnyVystupnyFormat;
        this.af.e.aktualnaTransformacia = this.aktualnaTransformacia;
        
        this.af.refreshAll();
    }
    
    public void redoAction() {
        this.aktualnyVstupnyFormat.jednoducheTransformacie.remove(mazanaTransformacia);
        
        this.af.e.aktualnyOkruh = this.aktualnyOkruh;
        this.af.e.aktualnyVstupnyFormat = this.aktualnyVstupnyFormat;
        this.af.e.aktualnyVystupnyFormat = this.aktualnyVystupnyFormat;
        this.af.e.aktualnaTransformacia = this.mazanaTransformacia;
        
        this.af.refreshAll();
    }
    
}
