package bakalarka;

import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


public class SelectBox {
	public int id;
	public ArrayList options = new ArrayList();
	Option vybrataOption = null;
	Option defaultOption = null;
	public String nazov = new String("");
	
	
	public void setNazov(String nazov) {
		this.nazov = nazov;
	}
	
	public void setID(int id) {
		this.id = id;
	}
	
	public boolean pridajOption(Option o) {
		o.setID(this.options.size());
		return this.options.add(o);
	}
	
	public Option getOptionByID(int id) {
		if (id >=0 && id < this.options.size()) {
			return ((Option) this.options.get(id));
		}
		return null;
	}
        
        public void changeOption(String nazov) {
            for (Iterator i = this.options.iterator(); i.hasNext();) {
                Option o = (Option) i.next();
                if (o.getNazov().compareTo(nazov) == 0) {
                    this.vybrataOption = o;
                    return;
                }
            }
        }
	
	public void setVybrataOption(Option o) {
		this.vybrataOption = o;
	}
	
	public void setDefaultnaOption(Option o) {
		this.defaultOption = o;
	}
        
        public void setVybrataOption(String meno) {
            for (Iterator i = this.options.iterator(); i.hasNext();) {
			Option o = ((Option) i.next());
			if ( o.getNazov().compareTo(meno) == 0 ) {
				this.vybrataOption = o;
                                return;
			}
		}
	}
	
        public Option getVybrataOption() {
            boolean defaultnaPatri = false;
            for (Iterator i = this.options.iterator();i.hasNext();) {
                    Option skumana = (Option) i.next();
                    if (skumana.equals(this.vybrataOption)) {
                            return skumana;
                    }
                    if (skumana.equals(this.defaultOption)) {
                            defaultnaPatri = true;
                    }
            }
            if (defaultnaPatri) {
                    return this.defaultOption;
            }
            if (this.options.size() > 0) {
                    return ((Option) this.options.get(0));
            } 
            return null;
        }
        
	public void setDefaultnaOption(String meno) {
		for (Iterator i = this.options.iterator(); i.hasNext();) {
			Option o = ((Option) i.next());
			if ( o.getNazov().compareTo(meno) == 0 ) {
				this.defaultOption = o;
                                return;
			}
		}		
	}
	
	public String getValue() {
		boolean defaultnaPatri = false;
		for (Iterator i = this.options.iterator();i.hasNext();) {
			Option skumana = (Option) i.next();
			if (skumana.equals(this.vybrataOption)) {
				return skumana.getValue();
			}
			if (skumana.equals(this.defaultOption)) {
				defaultnaPatri = true;
			}
		}
		if (defaultnaPatri) {
			return this.defaultOption.getValue();
		}
		if (this.options.size() > 0) {
			return ((Option) this.options.get(0)).getValue();
		} 
		return "";
	}
	
	public String getNormalizedValue() {
		boolean defaultnaPatri = false;
		for (Iterator i = this.options.iterator();i.hasNext();) {
			Option skumana = (Option) i.next();
			if (skumana.equals(this.vybrataOption)) {
				return skumana.getNormalizedValue();
			}
			if (skumana.equals(this.defaultOption)) {
				defaultnaPatri = true;
			}
		}
		if (defaultnaPatri) {
			return this.defaultOption.getNormalizedValue();
		}
		if (this.options.size() > 0) {
			return ((Option) this.options.get(0)).getNormalizedValue();
		} 
		return "";
	}
        
        public void paintPanel(SettingsPanel addedPanel, SettingsFrame sFrame) {
            Option o = this.getVybrataOption();
            if (o != null) {
                o.predpis.paintPanel(addedPanel, sFrame);
            }
        }
        
      
        public String printXML() {
            String result = new String("");
            result = result.concat("<selectbox ");
            if (this.defaultOption != null) {
                result = result.concat("default="+'"'+this.defaultOption.getNazov()+'"'+" ");
            }
            result = result.concat("meno="+'"'+this.nazov+'"'+">");
            for (Iterator i = this.options.iterator(); i.hasNext();) {
                result = result.concat(((Option) i.next()).printXML());
            }
            result = result.concat("</selectbox>");
            return result;
        }
        
        public String printFormattedXML(String tab) {
            String result = new String("");
            result = result.concat(tab+"<selectbox ");
            if (this.defaultOption != null) {
                result = result.concat("default="+'"'+this.defaultOption.getNazov()+'"'+" ");
            }
            result = result.concat("meno="+'"'+this.nazov+'"'+">"+System.getProperty("line.separator"));
            for (Iterator i = this.options.iterator(); i.hasNext();) {
                result = result.concat(((Option) i.next()).printFormattedXML(tab+ProgramSettingsHandler.tabulator));
            }
            result = result.concat(tab+"</selectbox>"+System.getProperty("line.separator"));
            return result;
        }
        
        public String nextAlternative(String alt) {
            String result = new String(alt);
            char[] abeceda = new char[] {'a', 'b', 'c', 'd', 'e','f', 'g', 'h', 'i', 'j','k', 'l', 'm', 'n', 'o','p', 'q', 'r', 's', 't','u', 'v', 'w', 'x', 'y', 'z'};
            if (alt.compareTo("") == 0) {
                result = new String(Character.toString(abeceda[0]));
            }
            else {
                char lastChar = alt.charAt(alt.length()-1);
                int index = -1;
                for (int i = 0; i < abeceda.length; i++) {
                    if (abeceda[i] == lastChar) {
                        index = i;
                        break;
                    }
                }
                if (index == -1 || index >= (abeceda.length-1)) {
                    result = result.concat(Character.toString(abeceda[0]));
                }
                else {                        
                    char newChar = abeceda[index+1];
                    char[] resultCharArray = result.toCharArray();
                    resultCharArray[resultCharArray.length-1] = newChar;
                    result = new String(resultCharArray);
                }
            }
            return result;
        }
        
        public String[] getOptionsAsStringArray() {
            if (this.options.size() > 0) {
                String[] result = new String[this.options.size()];
                int counter = 0;
                for (Iterator i = options.iterator(); i.hasNext(); counter++) {
                    result[counter] = ((Option) i.next()).getNazov();
                }
                return result;
            }
            return null;
        }

    public void paintOptionsEditorialPanel(SettingsPanel addedPanel, final JFrame aFrame, String cislovanie, final JComboBox optionsComboBox) {
        
        Insets nadpisIns = new Insets(15, 5, 0, 0);
        Insets smallIns = new Insets(5, 5, 0, 0);
        Insets atributIns = new Insets(5, 10, 0, 0);
        Insets panelIns = new Insets(5, 25, 0, 0);
        Insets noIns = new Insets(0, 0, 0, 0);        
        
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.anchor = GridBagConstraints.LINE_START;
        gbc.gridx = 0;
        gbc.gridy = -1;
         int counter = 1;
        for (Iterator i = this.options.iterator(); i.hasNext(); counter++) {
            final int nodeId = counter-1;
            Option option = (Option) i.next();
            cislovanie = this.nextAlternative(cislovanie);
            JLabel optionLabel = new JLabel(cislovanie+". Voľba");
            gbc.gridy++;
            gbc.insets = nadpisIns;
            addedPanel.add(optionLabel, gbc);
            
            
            
            JButton cancelNodeButton = new javax.swing.JButton();
            cancelNodeButton.setFont(new java.awt.Font("DejaVu Sans", 0, 10));
            cancelNodeButton.setText("Zrušiť");                
            cancelNodeButton.setEnabled(true);
            gbc.gridx = 1;
            gbc.fill = GridBagConstraints.NONE;
            addedPanel.add(cancelNodeButton, gbc);
            cancelNodeButton.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    odstranOption(nodeId);
                    ((AdministraciaFrame) aFrame).refreshPredpisArea();
                    ((AdministraciaFrame) aFrame).refreshNodesPanel();
                }
            });
            gbc.gridx = 0;
            gbc.fill = GridBagConstraints.BOTH;
            
            
            JLabel optionNameLabel = new JLabel("Názov:");
            gbc.gridy++;
            gbc.insets = atributIns;
            addedPanel.add(optionNameLabel, gbc);
                
            
            final JTextArea nazovArea = new JTextArea();
            nazovArea.setLineWrap(true);
            nazovArea.setWrapStyleWord(true);
            nazovArea.setRows(1);
            nazovArea.setColumns(20);
            nazovArea.setText(option.nazov);
            nazovArea.addKeyListener(new java.awt.event.KeyAdapter() {
               public void keyReleased(java.awt.event.KeyEvent evt) {
                   ((Option) options.get(nodeId)).nazov = nazovArea.getText();
                   ((AdministraciaFrame) aFrame).refreshPredpisArea();
                   //((AdministraciaFrame) aFrame).refreshNodesPanel();
                   String[] moznosti =getOptionsAsStringArray();
                   if (moznosti != null) {
                        int selIndex = 0;
                        if (defaultOption != null) {
                            for (int j = 0; j < moznosti.length; j++) {
                                if (moznosti[j].compareTo(defaultOption.nazov) == 0) {
                                    selIndex = j;
                                    break;
                                }
                            }
                        }
                        optionsComboBox.setModel(new javax.swing.DefaultComboBoxModel(moznosti));
                        optionsComboBox.setEnabled(true);
                        optionsComboBox.setSelectedIndex(selIndex);
                    }
                    else {
                        optionsComboBox.setEnabled(false);
                    }
                   nazovArea.grabFocus();
               }
            });

            JScrollPane nazovAreaScrollPane = new JScrollPane(nazovArea);
            nazovAreaScrollPane.setVerticalScrollBarPolicy(
                JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
            gbc.gridx = 1;
            gbc.insets = smallIns;
            addedPanel.add(nazovAreaScrollPane, gbc);
            gbc.gridx = 0;
            
            JLabel hodnotaLabel = new JLabel("Poduzly:");
            gbc.gridy++;
            gbc.insets = atributIns;
            addedPanel.add(hodnotaLabel, gbc);
            
            
            
            SettingsPanel newOptionPanel = new SettingsPanel();
            newOptionPanel.parent = addedPanel; 
            newOptionPanel.setLayout(new java.awt.GridBagLayout());                
            gbc.gridwidth = 500;
            gbc.gridy++;
            gbc.gridx = 0;
            gbc.fill = GridBagConstraints.NONE;
            gbc.insets = panelIns;
            option.predpis.paintEditorialPanel(newOptionPanel, aFrame, cislovanie);
            addedPanel.add(newOptionPanel, gbc);
            gbc.fill = GridBagConstraints.BOTH;
            gbc.gridwidth = 1;
        }
    }
    
    public void odstranOption(int index) {
        this.options.remove(id);
    }
    
}



